unit DAVSLArgs_AddOns;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates a VSL which simply shows a dialog in which it displays
the arguments passed by RUNADDON/RUNADDONWARGS (or menu/accel/tool item)

2000-09-20 GW
------------------------------------------------------------}

//========================================
               interface
//========================================

// Nothing absolutely needs to be exposed

//========================================
             implementation
//========================================
uses SysUtils, classes, forms, Visio_TLB, DAVAO, DAVSL, DAVSL_Util, DAVSLArgs_Form1;

Type
  //------------------------------
  TAddOnArgs_Open = class(TAddOn)
  //------------------------------
  public
    constructor Create;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
  end;


Var
  AddOnArgs_Open  : TAddOnArgs_Open ;

//------------------------------
// AddOn Description .
//------------------------------

//------------------------------------------------------
constructor TAddOnArgs_Open.Create;
//------------------------------------------------------
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT, // atts
    VAO_ENABLEALWAYS     , // enabMask
    0                    , // invokeOnMask
    0                    , // notifyOnMask
    'DAVSLArgs_Open'  , // lpName
    'Demo addon shows arguments passed, for example from RUNADDONWARGS'
  );
end;

//------------------------------------------------------
function TAddOnArgs_Open.vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC;
//------------------------------------------------------
Var
  S: string;
  N: integer;
begin
  Result := VAORC_SUCCESS;
  try
    If not Assigned(Form1) then // really not needed since modal
    Begin
      Form1 := TForm1.Create(Forms.Application);
      Form1.Memo1.Clear;
      For N := 0 to Args.Count-1 do
      Begin
        Form1.Memo1.Lines.Add(Args[N]);
      end;
      Form1.ShowModal;
    end;
  except
    on E: Exception do
    Begin
      ErrorMessage('Error: ' + E.Message);
      Form1.Free;
      Form1 := nil;
    end;
  end;
end;

initialization
  AddOnArgs_Open  := TAddOnArgs_Open.Create ;
end.

