unit DAVSLBeep_AddOns;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates a bare minimal VSL built with DAVSL, which simply beeps.

Revision History
----------------
2000-09-02 GW
------------------------------------------------------------}

//========================================
               interface
//========================================

// Nothing absolutely needs to be exposed

//========================================
             implementation
//========================================
uses SysUtils, classes, DAVAO, DAVSL;

Type
  //------------------------------
  TAddOnBeepBeep = class(TAddOn)
  //------------------------------
    constructor Create;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
  end;

Var
  AddOnBeepBeep: TAddOnBeepBeep;

//------------------------------------------------------
constructor TAddOnBeepBeep.Create;
//------------------------------------------------------
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT , // atts
    VAO_ENABLEALWAYS     , // enabMask
    0                    , // invokeOnMask
    0                    , // notifyOnMask
    'DAVSLBeep_Beep'           , // lpName
    'Minimal demo AddOn, simply beeps twice when called.'
  );
end;

//------------------------------------------------------
function TAddOnBeepBeep.vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC;
//------------------------------------------------------
begin
  Beep;
  Beep;
end;

initialization
  //-------------------------------------------------------------
  // Creates object for this AddOn, and Enlists it with GWVAO_Mgr
  //-------------------------------------------------------------
  AddOnBeepBeep := TAddOnBeepBeep.Create;
end.

