unit DAVSLColorForm_Form1;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates a VSL which shows a dialog with buttons for altering a
Shape's color.

2000-09-18 GW
------------------------------------------------------------}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Visio_TLB;

type
  TForm1 = class(TForm)
    bt_Red: TButton;
    bt_Green: TButton;
    bt_Blue: TButton;
    procedure bt_RedClick(Sender: TObject);
    procedure bt_GreenClick(Sender: TObject);
    procedure bt_BlueClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    VisioApp: Visio_TLB.Application;
    FSaveSessId: word;
  public
    { Public declarations }
    // Maintain reference to Visio here so that we can use this "controller"
    // from other code, not necessarily linked to VSL.
    property SaveSessId: word read FSaveSessId;
    constructor Create(AOwner: TComponent; AVisioApp: Visio_TLB.Application; ASessId: word);
    procedure ChangeColor(ColorNum: integer);
  end;

var
  Form1   : TForm1;

implementation
uses DAVSL;

{$R *.DFM}

//-------------------------------------------
constructor TForm1.Create(AOwner: TComponent; AVisioApp: Visio_TLB.Application; ASessId: word);
//-------------------------------------------
Begin
  inherited Create(AOwner);
  VisioApp   := AVisioApp;
  FSaveSessId := ASessId;
end;
//-------------------------------------------
procedure TForm1.ChangeColor(ColorNum: integer);
//-------------------------------------------
Var
  AWin: Visio_TLB.Window;
  AShape: Visio_TLB.Shape;
  ACell: Visio_TLB.Cell;
  S: string;
  FillForegnd: integer;
Begin
  try
    //------------------------------------
    // Set up arguments for "controller"
    //------------------------------------
    AWin := VisioApp.ActiveWindow;
    if not Assigned(AWin) then Raise Exception.Create('No active window');
    If AWin.Selection.Count <> 1 then Raise Exception.Create('Please select exactly one shape.');
    AShape := AWin.Selection[1];
    ACell  := AShape.Cells['FillForegnd'];
    ACell.Formula := IntToStr(ColorNum);
  except
    on E: Exception do ShowMessage('Error: ' + E.Message);
  end;
end;

//-------------------------------------------
procedure TForm1.bt_RedClick(Sender: TObject);
//-------------------------------------------
begin
  ChangeColor(2);
end;

//-------------------------------------------
procedure TForm1.bt_GreenClick(Sender: TObject);
//-------------------------------------------
begin
  ChangeColor(3);
end;

//-------------------------------------------
procedure TForm1.bt_BlueClick(Sender: TObject);
//-------------------------------------------
begin
  ChangeColor(4);
end;

//-------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
//-------------------------------------------
begin
  Action := caFree;
  Form1 := nil; // to signal it doesn't exist
  VSL.SendEndSession(SaveSessId);
end;

end.

