unit DAVSLEvents_Addons;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates a VSL which monitors events and reports them to a
VSL window.

2000-09-20 GW
------------------------------------------------------------}

interface
uses classes, DAVAO, DAVSL,  Visio_TLB;

Type
  //------------------------------
  TEvents_Show = class(TAddOn)
  //------------------------------
    constructor Create;

    function vlm_LOAD        (InterfaceVersion: word; visApp: Visio_TLB.Application): TVAORC; override;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
    function vlm_UNLOAD: TVAORC; override;
    function vlm_KILLSESSION (V2LRec: PVAOV2LRecord): TVAORC; override;
  end;

  //------------------------------
  TEvents_Hide = class(TAddOn)
  //------------------------------
    constructor Create;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
  end;


Var
  Events_Show  : TEvents_Show;
  Events_Hide : TEvents_Hide;

implementation
uses sysutils, DAVSLEvents_Control;

//------------------------------------------------------
constructor TEvents_Show.Create;
//------------------------------------------------------
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT, //  atts
    VAO_ENABLEALWAYS       , //  enabMask
    0                      , //  invokeOnMask
    0                      , //  notifyOnMask
    'DAVSLEvents_Show'   , //  lpName
    'Demo AddOn shows form which displays some Visio events'
  );
end;

//------------------------------------------------------
function TEvents_Show.vlm_LOAD(InterfaceVersion: word; visApp: Visio_TLB.Application): TVAORC;
//------------------------------------------------------
begin
  Result := EventController.Show_LOAD(visApp);
end;

//------------------------------------------------------
function TEvents_Show.vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC;
//------------------------------------------------------
Begin
  Result := EventController.Show_Run(V2LRec^.wSessID);
end;

//------------------------------------------------------
function TEvents_Show.vlm_UNLOAD: TVAORC;
//------------------------------------------------------
begin
  Result := EventController.Show_UNLOAD;
end;

//------------------------------------------------------
function TEvents_Show.vlm_KILLSESSION(V2LRec: PVAOV2LRecord): TVAORC;
//------------------------------------------------------
begin
  Result := EventController.Show_KILLSESSION(V2LRec^.wSessID);
end;

//------------------------------------------------------
constructor TEvents_Hide.Create;
//------------------------------------------------------
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT, //  atts
    VAO_ENABLEALWAYS       , //  enabMask
    0                      , //  invokeOnMask
    0                      , //  notifyOnMask
    'DAVSLEvents_Hide'   , //  lpName
    'Closes event monitor AddOn form, disables events'
  );
end;

//------------------------------------------------------
function TEvents_Hide.vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC;
//------------------------------------------------------
Begin
  Result := EventController.Hide_Run;
end;

initialization
  Events_Show  := TEvents_Show.Create;
  Events_Hide  := TEvents_Hide.Create;
end.

