unit DAVSLShapeChange_Control;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates AddOns which make use of several arguments with values which
are strings to be translated to integers. Note use of TArgInfo and TValInfo
to do this.

Revision History
----------------
2000-09-18 GW
------------------------------------------------------------}

interface
uses sysutils, Visio_TLB;
Type
  //-------------------------------
  TShapeChange_Controller = class
  //-------------------------------
    procedure ColorChange(AShape: Visio_TLB.Shape; FillForegnd, LineColor: integer);
    procedure AngleChange(AShape: Visio_TLB.Shape; Angle: integer);
  end;
Var
  ShapeChange_Controller: TShapeChange_Controller;

implementation

{ TShapeChange_Controller }
//-----------------------------------------------
procedure TShapeChange_Controller.AngleChange(AShape: Shape; Angle: integer);
//-----------------------------------------------
Var
  ACell: Visio_TLB.Cell;
  CellName, Formula: string;
begin
  CellName := 'Angle';
  Formula  := '=' + IntToStr(Angle) + ' deg.';
  ACell := AShape.Cells[CellName];
  ACell.Formula := Formula;
end;

//-----------------------------------------------
procedure TShapeChange_Controller.ColorChange(AShape: Shape; FillForegnd, LineColor: integer);
//-----------------------------------------------
Var
  ACell: Visio_TLB.Cell;
  CellName, Formula: string;
begin
  CellName := 'FillForegnd';
  Formula  := '=' + IntToStr(FillForegnd) ;
  ACell := AShape.Cells[CellName];
  ACell.Formula := Formula;

  CellName := 'LineColor';
  Formula  := '=' + IntToStr(LineColor) ;
  ACell := AShape.Cells[CellName];
  ACell.Formula := Formula;
end;

initialization
  ShapeChange_Controller := TShapeChange_Controller.Create;
end.

